

#for multiple wells
#diff no of wells and diff wieghts
#Optimization test 4 - minimize deviation for multiple wells

import time
from Optimizer import optimize
from scipy import optimize as sciopt
from scipy.optimize import Bounds as bnd
import numpy as np
from Interpolation_unitconvert import interpolation as int
file = optimize()  # Do not comment this out when running other optimization problems
file2 = int()  # Do not comment this out when running other optimization problems

start=time.time()
numberofwells = 5 #If this value is less than max possible wells, the result will show the remaining x's equal to x0
x0 = [500, 30000, 500, 30000, 500, 30000, 500, 30000, 500, 30000]
BHP = [120, 120, 120, 120, 120]
GOR = [91, 91, 91, 91, 91]
WC = [40, 45, 50, 55, 60]
presscons_val = [20, 20, 20, 20, 20]
glr_max_limit = 200000
OR_target = [1600, 1400, 1400, 1400, 1400]
GLR_target = [35000, 35000, 35000, 35000, 35000]
w1 = [1, 1, 1, 1, 1] #Weight on OR - OR_target for each well
w2 = [1, 1, 1, 1, 1] #Weight on GLR - GLR_target for each well
# #lb_var = [600, 15000, 500, 19000, 375, 23000, 300, 25000, 200, 27000]
# #lb_var = [600, 0, 500, 0, 375, 0, 300, 0, 200, 0]
lb_var = [40, 0, 40, 0, 40, 0, 40, 0, 40, 0]
ub_var = [1899, 110000, 1899, 110000, 1899, 110000, 1899, 110000, 1899, 110000]
res = file.min_dev_multiplewells('slsqp',numberofwells, x0, BHP, GOR, WC, presscons_val, glr_max_limit, OR_target, GLR_target, w1, w2, lb_var, ub_var)
print(res)

for i in range(numberofwells):
    Totaloil =+ res.x[2*i]
    print(f'Total oil production is {round(Totaloil, 2)}')

der = []
for i in range(numberofwells):
     result = (res.jac[i*2])/(res.jac[i*2 + 1])
     der.append(result)
print(f'The derivative dQoil/dQgaslift for the wells are {der}')

end = time.time()
print(f'Execution time is {end - start}')