# This file defines the class for interpolating the table
from scipy import interpolate as irp
from read_model import file1_read
import numpy as np
import pandas as pd
from pynverse import inversefunc

class interpolation:
    #Want to interpolate the numbers in each column in TPD results, given the variables. Number of dimensions has to change according to number of free variables. 
    #Every free variable are the points and the TPD res is the data? 
    #Something like:
    #For every column in TPD results:
    #   Interpolate the column in a dimension corresponding to number of free variables + 1 (TPD res). Have number of free variables in dictionary from read_model
    
    def __init__(self):
        self.dict = file1_read[0]
        self.df = file1_read[1]
        self.df_columns = []
        self.new_dim = []

    def get_points(self):
        l = []
        for i in range(len(self.dict)):
            points_dict = []
            df_to_arr = []
            points_dict = self.dict.get('Free_variable_'+str((len(self.dict)) - i)) #Get points from the dictionary they're stored in. Have to get the last element first in this list for the interpolation to be correct
            df_to_arr = points_dict.to_numpy() #Converts df to numpy array
            new_arr = df_to_arr.flatten() 
            l.append(new_arr)
        print(l)
        return l
    
    def convert_to_tup(self):
        list_input = self.get_points()
        self.convert_tuple = tuple(list_input)
        return self.convert_tuple
        
    #Get data to the points defined: Columns in TPS Res. This data should be on the regular grid in n dimensions (by def for interpolator)
    def get_data(self, col_numb):
        self.pnts = self.get_points()
        for i in range(len(self.df.columns)):
            col = self.df[i].to_numpy()
            self.df_columns.append(col)
        # If statement with many cases for new shapes (depending on number of free variables). This code accounts for: 1 <= free variables <= 6
        if len(self.pnts) == 0:
            return "The number of free variables needs to be at least 1"
        elif len(self.pnts) == 1:
            self.new_dim = np.reshape(self.df_columns[col_numb], newshape=(len(self.pnts[0])))
            return self.new_dim
        elif len(self.pnts) == 2:
            self.new_dim = np.reshape(self.df_columns[col_numb], newshape=(len(self.pnts[0]), len(self.pnts[1])))
            return self.new_dim
        elif len(self.pnts) == 3:
            self.new_dim = np.reshape(self.df_columns[col_numb], newshape=(len(self.pnts[0]), len(self.pnts[1]), len(self.pnts[2])))
            return self.new_dim
        elif len(self.pnts) == 4: 
            self.new_dim = np.reshape(self.df_columns[col_numb], newshape=(len(self.pnts[0]), len(self.pnts[1]), len(self.pnts[2]), len(self.pnts[3])))
            return self.new_dim
        elif len(self.pnts) == 5:
            self.new_dim = np.reshape(self.df_columns[col_numb], newshape=(len(self.pnts[0]), len(self.pnts[1]), len(self.pnts[2]), len(self.pnts[3]), len(self.pnts[4])))
            return self.new_dim
        elif len(self.pnts) == 6:
            self.new_dim = np.reshape(self.df_columns[col_numb], newshape=(len(self.pnts[0]), len(self.pnts[1]), len(self.pnts[2]), len(self.pnts[3]), len(self.pnts[4]), len(self.pnts[5])))
            return self.new_dim
        else:
            return "The number of free varibles is not between 1 and 6. The code needs adjustment in the file 'interpolation' and function 'get_data'."
    
    #Intepolate using linear interpolation 
    def do_interpolation(self, col_number):
        self.pnts = self.convert_to_tup()
        self.data = self.get_data(col_number)
        self.result = irp.RegularGridInterpolator(points=self.pnts, values=self.data, method="linear")
        return self.result

file = interpolation()
res = file.get_data(0)
print(np.size(res))


