### This is the main file 
import time
from optimizer import optimize

start = time.time()

## Run optimizer from this script

# Define object
opt_case1 = optimize()

# Input to optimizer
numberofwells = 5 #If this value is less than max possible wells, the result will show the remaining x's equal to x0
x0 = [500, 30000, 500, 30000, 500, 30000, 500, 30000, 500, 30000]#, 500, 30000, 500, 30000, 500, 30000]
BHP = [120, 120, 120, 120, 120]#, 120, 120, 120]
GOR = [91, 91, 91, 91, 91]#, 91, 91, 91]
WC = [40, 45, 50, 55, 60]#, 57, 57, 59]
presscons_val = [20, 20, 20, 20, 20]#, 20, 20, 20]
glr_max_limit = 200000
OR_target = [1600, 1400, 1400, 1400, 1400]#, 1400, 1400, 1400]
GLR_target = [35000, 35000, 35000, 35000, 35000]#, 35000, 35000, 35000]
w1 = [50, 1, 1, 1, 1]#, 1, 1, 1] #Weight on OR - OR_target for each well
w2 = [1, 1, 1, 1, 1]#, 1, 1, 1] #Weight on GLR - GLR_target for each wel
lb_var = [40, 0, 40, 0, 40, 0, 40, 0, 40, 0]#, 40, 0, 40, 0, 40, 0]
ub_var = [1899, 110000, 1899, 110000, 1899, 110000, 1899, 110000, 1899, 110000]#, 1899, 110000, 1899, 110000, 1899, 110000]

# Run optimization 
res = opt_case1.min_dev_multiplewells('slsqp',numberofwells, x0, BHP, GOR, WC, presscons_val, glr_max_limit, OR_target, GLR_target, w1, w2, lb_var, ub_var)
print(res)

# Print extra information of the result

##Find total oil
Totaloil = 0
for i in range(numberofwells):
    Totaloil = Totaloil + res.x[2*i]    
print(f'Total oil production is {round(Totaloil, 2)}')

## Find Jacobian dQoil/dQgaslift
der = []
for i in range(numberofwells):
    result = (res.jac[i*2 + 1])/(res.jac[i*2])
    der.append(result)
print(f'The derivative dQoil/dQgaslift for the wells are {der}')

## Print total gas lift injection used:
TotalGL = 0
for i in range(numberofwells):
    TotalGL = TotalGL + res.x[2*i + 1]
print(f'Total gas lift injection used is {round(TotalGL, 2)}')

end = time.time()

print(f'Execution time is {end - start}')