## This file is to read the .txt file to python using pandas 
import pandas as pd

class Read_Model:
    def __init__(self, file_name, file_location):
        self.file_name = file_name
        self.file_location = file_location
        self.row_numbers = []
        self.free_variable_name = 'values'
        self.TPD_res_name = 'variable tpd results'
        self.TPD_results = pd.DataFrame()
        self.df_fv_dict = {}
        
    def read_line(self, search_word):
        with open(f'{self.file_location}{self.file_name}') as openfile:
            i = 0
            self.row_numbers.clear()
            for line in openfile:
                i += 1
                if search_word in line.lower():
                    self.row_numbers.append(i)
            return self.row_numbers
        
    def read_rows_df(self, index, rows_imported):
        return pd.read_csv(f'{self.file_location}{self.file_name}', skiprows=self.row_numbers[index], nrows=rows_imported, header=None) #4 Variable TPD results starts at row 214
    
    def read_free_variables(self):
        self.read_line(self.free_variable_name)     # find lines with the "values" in it and remove the first two lines
        n = 2
        del self.row_numbers[:n]
        i = 0
        for i in range(len(self.row_numbers)):
            self.df_fv_dict['Free_variable_'+str(i + 1)] = self.read_rows_df(i, 1)
        return self.df_fv_dict
    
    def read_TPD_results(self):
        self.read_line(self.TPD_res_name)
        self.TPD_results = self.read_rows_df(0, None)
        return self.TPD_results
    
    def read_all(self):
        free_var = self.read_free_variables()
        TPD_res = self.read_TPD_results()
        return free_var, TPD_res 
     
## Inputs
text_file_1 = '\DHG2WH.txt' # Has to add a \ at the start
file_location_1 = r'C:\Users\Sogol\Desktop\Lundin Project\project production optimization 2022\projectall'

M1_file1 = Read_Model(text_file_1, file_location_1) #Define object
file1_read = M1_file1.read_all()

# # Read the text-file to python (model), using pandas
# ### TODO: make a loop that does this for every input-file defined above. Maybe store the inputs in an array/dict, and do what's below for everyone

# M1_file1 = Read_Model(text_file_2, file_location_2) #Define object
# file1_read = M1_file1.read_all()

#Test for plotting
#arr = file1_read[0].to_numpy()

#file1_read_var = M1_file1.read_free_variables()
#df = file1_read_var.get('Free_variable_5')
#TNP = df.to_numpy()




